#include<bits/stdc++.h>

using namespace std;

const int N = 1e6+1, A = 26+1;

struct node{
    int sum;
    int leaf;
    node* a[A];
    node(){
        sum = 0;
        leaf = false;
        for(int i = 0; i < A; ++i)
            a[i] = nullptr;
    }
};

int n, m;

node* go(node* v, char c){
    if(v->a[c-'a'] == nullptr){
        node* u = new node();
        v->a[c-'a'] = u;
    }
    return v->a[c-'a'];
}

node* root;

void add(string s, int ind){
    node* v = root;
    for(int i = 0; i < s.size(); ++i){
        ++v->sum;
        v = go(v, s[i]);
    }
    ++v->sum;
    v->leaf = ind;
}

int sz(node* v){
    return (v ? v->sum : 0);
}

int main(){
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);
    root = new node();
    cin >> n >> m;
    for(int i = 0; i < n; ++i){
        string s;
        cin >> s;
        add(s, i+1);
    }
    for(int i = 0; i < m; ++i){
        int k;
        string s;
        cin >> k >> s;
        node* v = root;
        for(int i = 0; i < s.size(); ++i)
            v = go(v, s[i]);
        if(k > sz(v)){
            cout << "-1\n";
            continue;
        }
        int ans = -1;
        while(true){
            if(k == 1 && v->leaf){
                ans = v->leaf;
                break;
            }
            for(int i = 0; i < 26; ++i){
                if(k <= sz(v->a[i])){
                    v = v->a[i];
                    break;
                }
                k -= sz(v->a[i]);
            }
        }
        cout << ans << '\n';
    }
}
