#include <bits/stdc++.h>

using namespace std;

int calc(const vector<int>& z, int len){
    int n = (int)z.size();
    vector<int> dp(len+z[n-1]+1, 1000000000);
    dp[z[0]] = 0;
    for (int i = 1; i < (int)z.size(); i++){
        for (int j = (int)dp.size()-1; j > z[i]; j--){
            dp[j] = min(dp[j], dp[j-z[i]]+10);
        }
        dp[z[i]] = 0;
    }
    int mn = 1000000000;
    for (int i = 0; i <= len; i++){
        mn = min(dp[i]+len-i, mn);
    }
    for (int i = len; i < (int)dp.size(); i++){
        mn = min(dp[i]+i-len, mn);
    }
    return mn;
}

void next(vector<int>& u){
    int n = u.size();
    u[n-1]++;
    int i = n-1;
    while (i > 0 && u[i] > 3){
        u[i] = 0;
        u[i-1]++;
        i--;
    }
}

int main(){
    ios_base::sync_with_stdio(false);


    //cout << calc(vector<int>({21,30}), 90) << endl;

    int n, a, b, c;
    cin >> n >> a >> b >> c;
    vector<int> v(n, 0), u(n, 0);
    for (int i = 0; i < n; i++){
        cin >> v[i];
    }


    int ans = 1000000000;
    while (u[0] < 4){
        vector<int> z;
        for (int i = 0; i < n; i++){
            if (u[i] == 1){
                z.push_back(v[i]);
            }
        }
        if (z.size() == 0){
            next(u);
            continue;
        }
        sort(z.begin(), z.end());
        int sum = calc(z, a);
        if (sum >= ans){
            next(u);
            continue;
        }
        z.clear();
        for (int i = 0; i < n; i++){
            if (u[i] == 2){
                z.push_back(v[i]);
            }
        }
        if (z.size() == 0){
            next(u);
            continue;
        }
        sort(z.begin(), z.end());
        sum += calc(z, b);
        if (sum >= ans){
            next(u);
            continue;
        }
        z.clear();
        for (int i = 0; i < n; i++){
            if (u[i] == 3){
                z.push_back(v[i]);
            }
        }
        if (z.size() == 0){
            next(u);
            continue;
        }
        sort(z.begin(), z.end());
        sum += calc(z, c);
        if (sum >= ans){
            next(u);
            continue;
        }
        ans = sum;
//        if (ans == 22){
//            for (int i = 0; i < n; i++){
//                cout << u[i] << " ";
//            }
//            cout << endl;
//        }
        next(u);
    }
    cout << ans << endl;
    return 0;
}














